.586
.model flat,stdcall
option casemap:none

	include TestGraph.inc

	IDE_VERTEXCOUNT	EQU 1001
	IDE_EDGECOUNT	EQU 1002
	IDS_VERTEXCOUNT	EQU 1101
	IDS_EDGECOUNT	EQU 1102
	IDB_TEST	EQU 1003
	IDC_VERTEXSIZE	EQU 1004
	IDS_VERTEXSIZE	EQU 1104
	IDE_CANVAS	EQU 1010
	IDB_CLRSCR	EQU 1005
	IDB_MOTION	EQU 1006
	IDB_GROW	EQU 1007

m2m	MACRO dest,src
	push	src
	pop	dest
ENDM


DUMY_VERTEX	STRUCT

			GRPH_VERTEX <>
		x	dd ?
		y	dd ?
	
DUMY_VERTEX	ENDS

DUMY_EDGE	STRUCT

			GRPH_EDGE <>
		delta	dd ?
		;red	dd ?,?
		;green	dd ?,?
		;blue	dd ?,?
	
DUMY_EDGE	ENDS


	WinMain		PROTO :DWORD,:DWORD,:DWORD,:DWORD
	CreateChildren	PROTO
	CanvasProc	PROTO :HWND,:UINT,:WPARAM,:LPARAM
	DrawGraph	PROTO
	MoveVertices	PROTO :DWORD
	InitGraph	PROTO
	CheckVertices	PROTO
	checkEdge	PROTO :DWORD,:DWORD

.data
	ClassName	db 'MainWinClass',0
	AppName		db 'Graph test',0
	szEditClass	db 'EDIT',0
	szStaticClass	db 'STATIC',0
	szButtonClass	db 'BUTTON',0
	szComboBoxClass	db 'COMBOBOX',0
	szCanvasClass	db 'CanvasClass',0
   
	szEdgeCount	db 'Edges:',0
	szVertexCount	db 'Vertices:',0
	szVertexSize	db 'Size:',0
	szTextButton	db 'Test',0
	szClrScr	db 'Clear',0
	szMotion	db 'Motion',0
	szGrow		db 'Grow',0

	bClrScr		db 0FFh
	bMotion		db 00h
	bGrow		db 00h

	dwVertexCount	dd 10
	dwEdgeCount	dd 0
	dwVertexSize	dd 7

.data?
	hInstance	HINSTANCE ?
	CommandLine	LPSTR ?
	lpBuffer	dd ?
	hMainWnd	dd ?
	Rect		RECT <>
	hFnt		dd ?
	hEditBox	dd ?

	hVertexCount	dd ?
	hEdgeCount	dd ?
	hData		dd ?
	hTestButton	dd ?
	hCanvas		dd ?
	hVertexSize	dd ?
	hClrScr		dd ?
	hMotion		dd ?
	hGrow		dd ?

	lpMyGraph	dd ?

	Const1		REAL8 ?
	temp		dd ?

.code

   include functions.asm

start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	
	invoke GetCommandLine
	mov    CommandLine,eax
	
	invoke GetTickCount
	invoke nseed,eax
	
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND

	mov	wc.cbSize,SIZEOF WNDCLASSEX
	mov	wc.style, CS_HREDRAW or CS_VREDRAW
	mov	wc.lpfnWndProc, OFFSET WndProc
	mov	wc.cbClsExtra,NULL
	mov	wc.cbWndExtra,NULL
	m2m	wc.hInstance,hInstance
	mov	wc.hbrBackground,COLOR_BTNFACE+1
	mov	wc.lpszMenuName,NULL
	mov	wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov	wc.hIcon,eax
	mov	wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov	wc.hCursor,eax
	invoke RegisterClassEx,addr wc

	mov	Rect.left,0
	mov	Rect.top,0
	mov	Rect.right,644
	mov	Rect.bottom,484+32
	invoke AdjustWindowRectEx,offset Rect,WS_SYSMENU or WS_CAPTION or WS_EX_CLIENTEDGE,FALSE,NULL
	push	NULL
	push	hInst
	push	NULL
	push	NULL
	mov	eax,Rect.bottom
	sub	eax,Rect.top
	push	eax
	mov	eax,Rect.right
	sub	eax,Rect.left
	push	eax
	push	CW_USEDEFAULT
	push	CW_USEDEFAULT
	push	WS_SYSMENU or WS_CAPTION or WS_CLIPCHILDREN
	push	offset AppName
	push	offset ClassName
	push	NULL
	call CreateWindowEx
	mov   hwnd,eax
	
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW

	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	.IF uMsg==WM_DESTROY
		invoke FreeSDraw
		invoke GRPH_destroy,lpMyGraph
		invoke PostQuitMessage,NULL
	.ELSEIF uMsg==WM_CREATE
		m2m	hMainWnd,hWnd
		invoke	GlobalAlloc,GPTR,128
		mov	lpBuffer,eax
		invoke InitSDraw,640,480
		invoke CreateChildren
		invoke dwtoa,dwVertexCount,lpBuffer
		invoke SetWindowText,hVertexCount,lpBuffer
		invoke dwtoa,dwEdgeCount,lpBuffer
		invoke SetWindowText,hEdgeCount,lpBuffer
		invoke SendMessage,hClrScr,BM_SETCHECK,BST_CHECKED,0
		invoke EnableWindow,hGrow,FALSE

	.ELSEIF uMsg==WM_COMMAND
		.IF wParam==IDB_TEST
			invoke GetDlgItemInt,hMainWnd,IDE_VERTEXCOUNT,NULL,FALSE
			or	eax,eax
			jnz @F
				mov	eax,1
				invoke SetDlgItemInt,hMainWnd,IDE_VERTEXCOUNT,eax,FALSE
		@@:
			mov	dwVertexCount,eax

			invoke GetDlgItemInt,hMainWnd,IDE_EDGECOUNT,NULL,FALSE
;			or	eax,eax
;			jnz @F
;				mov	eax,1
;		@@:
			mov	ecx,eax
			mov	eax,dwVertexCount
			mul DWORD PTR dwVertexCount
			sub	eax,dwVertexCount
			shr	eax,1
			cmp	ecx,eax
			ja @F
				mov	eax,ecx
		@@:
			mov	dwEdgeCount,eax
			invoke SetDlgItemInt,hMainWnd,IDE_EDGECOUNT,eax,FALSE

			invoke InitGraph
			invoke RedrawWindow,hCanvas,NULL,NULL,RDW_INVALIDATE
			;invoke SendMessage,hCanvas,WM_PAINT,0,0
		.ELSE
			mov	ecx,lParam
			mov	eax,wParam
			cmp	ecx,hVertexSize
			jnz @F
				shr	eax,16
				cmp	eax,CBN_SELCHANGE
				jnz @F
					invoke SendMessage,hVertexSize,CB_GETCURSEL,0,0
					shl	eax,1
					add	eax,1
					mov	dwVertexSize,eax
					jmp @End
		@@:
			cmp	ecx,hClrScr
			jnz @F
				mov	al,bClrScr
				not	al
				mov	bClrScr,al
				jmp @End
		@@:
			cmp	ecx,hMotion
			jnz @F
				movzx	eax,bMotion
				not	al
				mov	bMotion,al
				invoke EnableWindow,hGrow,eax
				jmp @End
		@@:
			cmp	ecx,hGrow
			jnz @F
				mov	al,bGrow
				not	al
				mov	bGrow,al
				jmp @End
		@@:
		.ENDIF
	.ELSE
@Default:	
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
@End:
	xor eax,eax
	ret
WndProc endp

end start
